/***************************************\
 * $Log: upm.c,v $
 * Revision 1.1  2000/11/11 18:21:42  ian
 * Initial revision
 *
 * Revision 1.1  2000/09/12 18:04:30  ian
 * Initial revision
 *
 * 
\***************************************/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include <assert.h>
#include <NCCAPixmap.h>
#include <PixFileIO.h>

#include <math.h>


int main(int argc, char*argv[])
{
	NCCAPixmap oldImg;
	NCCAPixmap newImg;
	int blur=0;

	int i,j;

	if(argc!=4)
		{
		fprintf(stderr,"DCT blur\n");
		fprintf(stderr,"blur blur amount oldimage newimage\n");
		exit(-1);
		}
	blur=atoi(argv[1]);
	if(blur<=0)
		{
		fprintf(stderr,"Bad blur value (%d)\n",blur);
		exit(-1);
		}
	
	oldImg=loadPixmap(argv[2]);
	if(oldImg.data==NULL)
		{
		fprintf(stderr,"Couldn't load %s\n",argv[2]);
		exit(-1);
		}
	
	newImg=newPixmapLike(oldImg);
	for(i=0;i<oldImg.width;i++)
		for(j=0;j<oldImg.height;j++)
			{
			NCCAPixel p;
			int s;
			p=getPixel(oldImg,i,j);
			for(s=1;s<blur;s++)
				{
				NCCAPixel q;
				q=getPixel(oldImg,
					i+(random()%s-s*0.5),
					j+(random()%s-s*0.5));
				p.r+=q.r;
				p.g+=q.g;
				p.b+=q.b;
				p.a+=q.a;
				}
			p.r/=blur;
			p.g/=blur;
			p.b/=blur;
			p.a/=blur;
			
			setPixelColour(newImg,i,j,p);
			}

	savePixmap(newImg, argv[3]);
	return 0;
}
