#include <iostream>
#include <fstream>

#include "spectra.h"

spectra::spectra()
{

}

spectra::spectra(string rfile,string gfile,string bfile)
{
	read(rfile,gfile,bfile);
}

spectra::~spectra()
{

}

const spectra& spectra::operator = (const spectra &rhs)
{
	r = rhs.r;
	g = rhs.g;
	b = rhs.b;
	return *this;
}

void spectra::read_ch(string filename, int ch)
{
	fstream filein;
	
	filein.open(filename.c_str(),ios::in);
	if(!filein.is_open())
		{
		cout<<"File : "<<filename<<" does not exist"<<endl;
		exit(1);
		}
		
	while(!filein.eof())
	{
		amirVector temp;
		filein>>temp.x;
		filein>>temp.y;
		
		switch(ch)
		{
			case 0:
				r.push_back(temp);
				break;
			case 1:
				g.push_back(temp);
				break;
			case 2:
				b.push_back(temp);
				break;
			default:
				break;
		}
	}
	filein.close();
	
	switch(ch)
	{
		case 0:
			r.pop_back();
			break;
		case 1:
			g.pop_back();
			break;
		case 2:
			b.pop_back();
			break;
		default:
			break;
	}
}


void spectra::read(string rfile,string gfile,string bfile)
{
	read_ch(rfile,0);
	read_ch(gfile,1);
	read_ch(bfile,2);
}

void spectra::print_ch(int ch)
{
	switch(ch)
	{
		case 0:
			for(int i=0; i < r.size(); ++i)
				cout<<r[i].x<<"\t"<<r[i].y<<endl;
			break;
		case 1:
			for(int i=0; i < g.size(); ++i)
				cout<<g[i].x<<"\t"<<g[i].y<<endl;
			break;
		case 2:
			for(int i=0; i < b.size(); ++i)
				cout<<b[i].x<<"\t"<<b[i].y<<endl;
			break;
		default:
			break;
	}
}

void spectra::print()
{
	print_ch(0);
	print_ch(1);
	print_ch(2);
}



void spectra::scale(char ch, char xy, double val)
{
	switch(ch)
	{
		case 0:
			for(int i = 0; i < r.size(); ++i)
				if(xy == 0)
					r[i].x *= val;
				else
					r[i].y *= val;
		case 1:
			for(int i = 0; i < g.size(); ++i)
				if(xy == 0)
					g[i].x *= val;
				else
					g[i].y *= val;
		case 2:
			for(int i = 0; i < b.size(); ++i)
				if(xy == 0)
					b[i].x *= val;
				else
					b[i].y *= val;
		default:
			break;
	}
}


double spectra::get(char ch, char xy, char id)
{
	switch(ch)
	{
		case 0:
			if(xy == 0)
				return r[id].x;
			else
				return r[id].y;
		case 1:
			if(xy == 0)
				return g[id].x;
			else
				return g[id].y;
		case 2:
			if(xy == 0)
				return b[id].x;
			else
				return b[id].y;
		default:
			break;
	}
}






