#include <cmath>
#include <iostream>
#include "vector.h"
#include "matrix.h"


amirVector::amirVector()
{
x=0;
y=0;
z=0;
}

amirVector::amirVector(double _x, double _y, double _z)
{
x=_x;
y=_y;
z=_z;
}

amirVector::amirVector(const amirVector &copy)
{
x = copy.x;
y = copy.y;
z = copy.z;
}

amirVector::~amirVector()
{

}

const amirVector& amirVector::operator = (const amirVector &rhs)
{
	x = rhs.x;
	y = rhs.y;
	z = rhs.z;
	return *this;
}

amirVector amirVector::operator + (const amirVector &rhs)
{
	amirVector temp;
	temp.x = x + rhs.x;
	temp.y = y + rhs.y;
	temp.z = z + rhs.z;
	return temp;
}

amirVector amirVector::operator - (const amirVector &rhs)
{
	amirVector temp;
	temp.x = x - rhs.x;
	temp.y = y - rhs.y;
	temp.z = z - rhs.z;
	return temp;
}

amirVector amirVector::operator += (const amirVector &rhs)
{

    x += rhs.x;
	y += rhs.y;
	z += rhs.z;
	return *this; 
}

void amirVector::set(double _x, double _y, double _z)
{
		amirVector::x = _x; 
		amirVector::y = _y; 
		amirVector::z = _z; 
}


double amirVector::length() 
{
	return sqrt(x*x + y*y + z*z);
}

void amirVector::normalize() 
{
	double l = length();
	x /= l;
	y /= l;
	z /= l;
}

void amirVector::print()
{
	cout<< x << "  "<< y << "  " << z << "" <<endl;
}


bool amirVector::operator < (const amirVector &rhs) {
	if(x < rhs.x && y < rhs.y && z < rhs.z) {
		return true;
	} else {
		return false;
	}
}


void amirVector::multMatrix(matrix multi)
{
float x1 = multi.getElement(matrix::_11)*x + multi.getElement(matrix::_12)*y + multi.getElement(matrix::_13)*z + multi.getElement(matrix::_14);
float x2 = multi.getElement(matrix::_21)*x + multi.getElement(matrix::_22)*y + multi.getElement(matrix::_23)*z + multi.getElement(matrix::_24);
float x3 = multi.getElement(matrix::_31)*x + multi.getElement(matrix::_32)*y + multi.getElement(matrix::_33)*z + multi.getElement(matrix::_34);
	x=x1; y=x2; z=x3;
}



void amirVector::xyzTOrgb() 
{
	amirVector temp(x,y,z);
	matrix rgb_converter( 1.75526,    -0.544134,    0.00634681, 0.0,
						 -0.483679,    1.50688,    -0.0175762,  0.0, 
						 -0.253000,    0.0215528,   1.22570,    0.0,
						  0.0,         0.0,         0.0,        1.0 );
						 
						 
						 
/*2.95176    -1.0851      0.0854804  
-1.28951     1.99084    -0.269456   
-0.47388     0.0372023   1.09113 	*/
						
	temp.multMatrix(rgb_converter);
	x = temp.x;
	y = temp.y;
	z = temp.z;
}
